lit   lit2val  [0-9]+
opad  op2lex   \+|-
opmul None     \*
pa    None     \(
pc    None     \)
None  None     [ \t\n]+

%

ord0=ord("0")

def lit2val(cl):
    v=0
    for d in cl.lexema:
        v=v*10+(ord(d)-ord0)
    cl.val=v

def op2lex(cl):
    cl.lex=cl.lexema

import AST

%

<X> -> <E> @self.arb=E.arb@ ;

<E> -> <S> @aux=S1.arb@ ( opad <S> @if opad.lex=="+":          @
                                   @  aux=AST.Mas(aux,S2.arb)  @
                                   @else:                      @
                                   @  aux=AST.Menos(aux,S2.arb)@
                        )* @E.arb=aux@ ;

<S> -> <F> @aux=F1.arb@ ( opmul <F> @aux=AST.Por(aux,F2.arb)@ 
                        )* @S.arb=aux@ ;

<F> -> lit @F.arb=AST.Cte(lit.val)@
     | pa <E> pc @F.arb=E.arb@ ;

%

def main():

##  al=AnalizadorLexico(sys.stdin)
##  while 1:
##    cl=al.avanza()
##    if cl.cat=="mc_EOF": break
##    print cl

  as=AnalizadorSintactico(sys.stdin)
  print as.arb, "=", as.arb.evalua()
