class Cte:
    def __init__(self,v):
        self.v=v

    def evalua(self):
        return self.v

    def __str__(self):
        return "( %s )" % (self.v)

class Mas:
    def __init__(self,hi,hd):
        self.hi=hi
        self.hd=hd

    def evalua(self):
        vi=self.hi.evalua()
        vd=self.hd.evalua()
        return vi+vd

    def __str__(self):
        return "( %s + %s )" % (self.hi,self.hd)

class Menos:
    def __init__(self,hi,hd):
        self.hi=hi
        self.hd=hd

    def evalua(self):
        vi=self.hi.evalua()
        vd=self.hd.evalua()
        return vi-vd

    def __str__(self):
        return "( %s - %s )" % (self.hi,self.hd)

class Por:
    def __init__(self,hi,hd):
        self.hi=hi
        self.hd=hd

    def evalua(self):
        vi=self.hi.evalua()
        vd=self.hd.evalua()
        return vi*vd

    def __str__(self):
        return "( %s * %s )" % (self.hi,self.hd)
